// -*- C++ -*- generated by wxGlade 0.3.5.1 on Wed Jun 29 12:57:38 2005
#include <wx/regex.h>
#include <wx/tokenzr.h>
#include <wx/xrc/xmlres.h>
#include "mnID.h"
#include "mnDef.h"
#include "mnNotePanel.h"
#include "mnDialog.h"
#include "mnNotePanelController.h"

mnNotePanel::mnNotePanel(wxWindow* parent, wxString* dirName)
{
	wxXmlResource::Get()->LoadPanel(this, parent, wxT("notePanel"));
	searchTree       = XRCCTRL(*this, "searchTree", wxTreeCtrl);

#ifdef __WXMAC__
	wxSplitterWindow* spWindow = XRCCTRL(*this, "splitWindow", wxSplitterWindow);
	wikiHtmlTextCtrl = new mnHtmlWindow(spWindow, -1, wxT(""), wxDefaultPosition, wxSize(200, 200));
	spWindow->SplitVertically(searchTree, wikiHtmlTextCtrl, 250);
#else
	/* init members */
	wxFont font(12, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL);	
	wikiHtmlTextCtrl = XRCCTRL(*this, "wikiHtmlTextCtrl", mnHtmlWindow);
	wikiHtmlTextCtrl->SetFonts(font.GetFaceName(), font.GetFaceName());
#endif


	/* create search tree */
	searchItemRoot = searchTree->AddRoot(wxT(LABEL_ITEM_TREE), -1, -1, NULL);
	
	/* create controller, and push as event handler */
	panelController = new mnNotePanelController(this, dirName);
	PushEventHandler(panelController);	
}

mnNotePanelController* mnNotePanel::getController()
{
	return panelController;
}

void mnNotePanel::updateSearchResult(mnModel* wiki, wxString* searchStr, bool isExpand)
{
	wxTreeItemIdValue cookie1, cookie2;
	wxTreeItemId      searchStrId;
	wxTreeItemId      wikiDataId;
	const WikiList* wikiList;
	WikiList::Node* node;
	WikiData*       data;
	const wxString* subject;

	memset(&cookie1, 1, sizeof(cookie1));
	memset(&cookie2, 2, sizeof(cookie2));
	searchStrId = searchTree->GetFirstChild(searchItemRoot, cookie1);
	while(searchStrId.IsOk()) {
		if(searchTree->GetItemText(searchStrId) == *searchStr) {
			wikiDataId = searchTree->GetFirstChild(searchStrId, cookie2);
			while(wikiDataId.IsOk()) {
				searchTree->SetItemData(wikiDataId, NULL);
				wikiDataId = searchTree->GetNextChild(searchStrId, cookie2);
			}
			searchTree->DeleteChildren(searchStrId);
			break;
		}		
		searchStrId = searchTree->GetNextChild(searchItemRoot, cookie1);
	}

	wikiList = wiki->getSearchResultList(searchStr);
	if(wikiList == NULL) {
		MN_FATAL_ERROR(wxT("wikiList is null"));
		return;
	}

	node = wikiList->GetFirst();
	while(node) {
		data = node->GetData();
		subject = data->getSubject();
		searchTree->AppendItem(searchStrId, *subject, -1, -1, (wxTreeItemData*)data);
		node = node->GetNext();
	}
	if(isExpand){
	   	searchTree->Expand(searchStrId);
	}
	else {
	   	searchTree->Collapse(searchStrId);
	}
}


void mnNotePanel::addSearchResult(mnModel* wiki, wxString* searchStr, bool isExpand)
{
	wxTreeItemId    searchItem;
	const WikiList* wikiList;
	WikiList::Node* node;
	WikiData*       data;
	const wxString* subject;

	wikiList = wiki->getSearchResultList(searchStr);
	if(wikiList == NULL) {
		MN_FATAL_ERROR(wxT("wikiList is null"));
		return;
	}

	//searchItem = searchTree->AppendItem(searchItemRoot, *searchStr, -1, -1, NULL);
	searchItem = searchTree->InsertItem(searchItemRoot, 0, *searchStr, -1, -1, NULL);
	node = wikiList->GetFirst();
	while(node) {
		data = node->GetData();
		subject = data->getSubject();
		searchTree->AppendItem(searchItem, *subject, -1, -1, (wxTreeItemData*)data);
		node = node->GetNext();
	}

	searchTree->Expand(searchItemRoot);
	if(isExpand){
	   	searchTree->Expand(searchItem);
	}
	else {
	   	searchTree->Collapse(searchItem);
	}
}

void mnNotePanel::makeHtml(WikiData* wikiData, bool isHighlight)
{
	const wxString* fileName = wikiData->getFileName();
	const wxString* wikiText = wikiData->getText();
	wxString htmlText(*wikiText);

	/* escape < */
	wxRegEx exp01(wxT("<"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp01.Replace(&htmlText, wxT("\\&lt "));

	/* escape > */
	wxRegEx exp02(wxT(">"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp02.Replace(&htmlText, wxT("\\&gt "));
 	
	/* http://  */	
	wxRegEx exp2(wxT("((http|https|ftp)://[-_.!~*'a-zA-Z0-9;/?:@&=+$,%#]+)"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp2.Replace(&htmlText, wxT("<a href=\\1>\\1</a>"));
	
	/* [[ ]] */
	wxRegEx exp1(wxT("\\[\\[([^]]+)\\]\\]"));
	exp1.Replace(&htmlText, wxT("<a href=\"" MNLINK "\\1\">\\1</a>"));

 	/* file://  */	
	wxRegEx exp3(wxT("(file://[^ ]+)"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp3.Replace(&htmlText, wxT("<a href=\\1>\\1</a>"));
	
	/* **XXXX */
	wxRegEx exp5(wxT("^\\*\\*([^*]+)"), wxRE_NEWLINE|wxRE_DEFAULT);
#ifdef __WXMAC__
	exp5.Replace(&htmlText, wxT("<TABLE WIDTH=\"100%\" CELLPADDING=2 CELLSPACING=1 BORDER=0><TR><TD BGCOLOR=\"#CCFFFF\"><FONT SIZE=3><B>\\1</B></FONT></TD></TR></TABLE>"));
#else
	exp5.Replace(&htmlText, wxT("<TABLE WIDTH=\"100%\" CELLPADDING=2 CELLSPACING=1 BORDER=0><TR><TD BGCOLOR=\"#CCFFFF\"><FONT SIZE=3><B>\\1</B></FONT></TD></TR></TABLE><BR>"));
#endif

	/* *XXXX */
	wxRegEx exp4(wxT("^\\*([^*]+)"), wxRE_NEWLINE|wxRE_DEFAULT);
#ifdef __WXMAC__
	exp4.Replace(&htmlText, wxT("<TABLE WIDTH=\"100%\" CELLPADDING=5 CELLSPACING=2 BORDER=1><TR><TD BGCOLOR=\"#CCFFFF\"><FONT SIZE=4><B>\\1</B></FONT></TD></TR></TABLE>"));
#else
	exp4.Replace(&htmlText, wxT("<TABLE WIDTH=\"100%\" CELLPADDING=5 CELLSPACING=2 BORDER=1><TR><TD BGCOLOR=\"#CCFFFF\"><FONT SIZE=5><B>\\1</B></FONT></TD></TR></TABLE><BR>"));
#endif
	
	/* :''XXXX'': */
	wxRegEx exp6(wxT("^:''(.+)'':(.+)"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp6.Replace(&htmlText, wxT("<u><b>\\1:\\2</b></u>"));

	/* ---- */
	wxRegEx exp7(wxT("^----.*"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp7.Replace(&htmlText, wxT("<hr>"));

	/* {{ }} */
	wxRegEx exp8(wxT("\\{\\{([^\\}]+)\\}\\}"));
	exp8.Replace(&htmlText, wxT("<a href=\"" MNDOC "\\1\">\\1</a>"));

	/* table */
	wxRegEx exp10(wxT("^,([^,]+)"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp10.Replace(&htmlText, wxT("<td> \\1 </td>"));
	for(int i = 0; i < 10; i++){ // It's not good.  :P
		wxRegEx exp16(wxT("</td>,([^,\n]+)"), wxRE_DEFAULT);
		exp16.Replace(&htmlText, wxT("</td><td>\\1</td>"));
	}
	wxRegEx exp11(wxT("^<td>"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp11.Replace(&htmlText, wxT("<tr><td>"));
	wxRegEx exp12(wxT("</td>$"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp12.Replace(&htmlText, wxT("</td></tr>"));
	wxRegEx exp15(wxT("</tr>\n"));
	exp15.Replace(&htmlText, wxT("</tr>"));

	wxRegEx exp13(wxT("^<tr>"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp13.Replace(&htmlText, wxT("<table border><tr>"));
	wxRegEx exp14(wxT("</tr>$"), wxRE_NEWLINE|wxRE_DEFAULT);
	exp14.Replace(&htmlText, wxT("</tr></table>"));

	
	/* Highlight search text */
	highlight = isHighlight;
	if(isHighlight) {
        wxTreeItemId parentId = searchTree->GetItemParent(searchTree->GetSelection());
		wxString     searchWords = searchTree->GetItemText(parentId);
		wxStringTokenizer tkz(searchWords, wxT(" "));
		while ( tkz.HasMoreTokens() )
		{
			wxString token = tkz.GetNextToken();
			wxRegEx exp9(wxT("(?!<[^>]+)(") + token + wxT(")(?![^<]+>)"), wxRE_ADVANCED|wxRE_ICASE|wxRE_NEWLINE);
			exp9.Replace(&htmlText, wxT("<b><font color=\"red\">\\1</font></b>"));
		}
	}

	/* make HTML document */
	wxString wikiHtml;
	wikiHtml.Append(wxT("<meta http-equiv=\"Content-Type\" content=\"text/html; charset="));
	wikiHtml.Append(wxT(CODE_SET_SYSTEM));
	wikiHtml.Append(wxT("\">"));
	wikiHtml.Append(wxT("<pre>"));
	wikiHtml.Append(wxT("<html>"));
	wikiHtml.Append(htmlText.c_str());
	wikiHtml.Append(wxT("</pre>"));
	wikiHtml.Append(wxT("</html>"));

	wikiHtmlTextCtrl->SetPage(wikiHtml);
}

void mnNotePanel::showSelectedItemText(wxTreeEvent& event)
{
	wxTreeItemId    id;
	wxTreeItemData* item;

	id = searchTree->GetSelection();
	item = searchTree->GetItemData(id);

	if(!id.IsOk() || !isEditableTreeLabel(id) || item == NULL) { /* selection is not memo data */
		wikiHtmlTextCtrl->SetPage(wxT("<html></html>"));
		return;
	}
	makeHtml((WikiData*)item, false);
}

wxTreeItemId mnNotePanel::getSelection()
{
	return searchTree->GetSelection();
}

void mnNotePanel::highlightSelectedItem()
{
	wxTreeItemData* item    = getSelectedItem();
	
	if(!isEditableTreeLabel(searchTree->GetSelection())) { /* selection is not memo data */
		wikiHtmlTextCtrl->SetPage(wxT(""));
		return;
	}

	if(highlight){
		makeHtml((WikiData*)item, false);
	}
	else {
		makeHtml((WikiData*)item, true);
	}
}


void mnNotePanel::expandAllTree()
{
	wxTreeItemIdValue cookie;
	wxTreeItemId      itemId;

	memset(&cookie, 1, sizeof(cookie));
	itemId = searchTree->GetFirstChild(searchItemRoot, cookie);
	while(itemId.IsOk()) {
		searchTree->Expand(itemId);	
		itemId = searchTree->GetNextChild(searchItemRoot, cookie);
	}
}

void mnNotePanel::collapseAllTree()
{
	wxTreeItemIdValue cookie;
	wxTreeItemId      itemId;

	memset(&cookie, 1, sizeof(cookie));
	itemId = searchTree->GetFirstChild(searchItemRoot, cookie);
	while(itemId.IsOk()) {
		searchTree->Collapse(itemId);	
		itemId = searchTree->GetNextChild(searchItemRoot, cookie);
	}
}

void mnNotePanel::clearAllTree()
{
	wxTreeItemIdValue cookie1, cookie2;
	wxTreeItemId      searchStrId;
	wxTreeItemId      wikiDataId;

	memset(&cookie1, 1, sizeof(cookie1));
	memset(&cookie2, 2, sizeof(cookie2));
	searchStrId = searchTree->GetFirstChild(searchItemRoot, cookie1);
	while(searchStrId.IsOk()) {
		wikiDataId = searchTree->GetFirstChild(searchStrId, cookie2);
		while(wikiDataId.IsOk()) {
			searchTree->SetItemData(wikiDataId, NULL);
			wikiDataId = searchTree->GetNextChild(searchStrId, cookie2);
		}
		searchStrId = searchTree->GetNextChild(searchItemRoot, cookie1);
	}

	searchTree->DeleteChildren(searchItemRoot);
}

void mnNotePanel::removeSelectedItem()
{
	searchTree->Delete(searchTree->GetSelection());
}

wxTreeItemData* mnNotePanel::getSelectedItem()
{
	return searchTree->GetItemData(searchTree->GetSelection());
}

wxString mnNotePanel::getSelectedLabel()
{
	return searchTree->GetItemText(searchTree->GetSelection());
}

bool mnNotePanel::isEditableTreeLabel(wxTreeItemId id)
{
	if(id.IsOk()){ 
		return !(searchTree->GetItemParent(id) == searchItemRoot || id == searchItemRoot);
	}
	else {
		return false;
	}
}

